#include <stdio.h>
#include <stdlib.h>

int validar(int sequencia[], int n, int K) {
    int soma = 0, produto = 1, absoluto = 0;

    // Verificar soma e produto simultaneamente
    for (int i = 0; i < n; i++) {
        soma += sequencia[i];
        produto *= sequencia[i];
    }
    if (soma > K) {
        return 0;
    }
    if (produto < K) {
        return 0;
    }

    // Verificar valor absoluto
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            absoluto += abs(sequencia[i] - sequencia[j]);
        }
    }

    return (absoluto == K) ? 2 : 1;
}

int main() {
    int sequencia[100], n = 0, K;
    char terminatorChar;

    // Solicitar K ao usuário e verificar se é um número inteiro entre 2 e 100
    printf("Indique K: ");
    if (scanf("%d%c", &K, &terminatorChar) != 2 || (terminatorChar != '\n' && terminatorChar != ' ') || K < 2 || K > 100) {
        printf("K tem de ser entre 2 e 100.\n");
        return 1;
    }

    // Solicitar sequência de números ao usuário
    printf("Indique uma sequencia de numeros inteiros positivos, terminando com 0: ");
    while (n < 100) {
        int valor;
        if (scanf("%d", &valor) != 1 || valor < 0) {
            printf("Entrada inválida! Apenas números inteiros positivos são permitidos.\n");
            return 1;
        }
        if (valor == 0) {
            break;
        }
        sequencia[n++] = valor;
    }

    // Verificar se a sequência é válida
    int resultado = validar(sequencia, n, K);
    if (resultado == 2) {
        printf("Sequencia vitoria\n");
    } else if (resultado == 1) {
        printf("Sequencia valida\n");
    } else {
        printf("Sequencia invalida\n");
    }

    return 0;
}