#include <stdio.h>  // Biblioteca padrão para entrada e saída
#include <stdlib.h> // Biblioteca padrão para funções como abs()

// Protótipo da função de validação
int validar(int sequencia[], int n, int K);

int main() {
    int sequencia[100]; // Array que armazena a sequência do jogo
    int n = 2, K, indice, valor, resultado = 1; // Variáveis de controle e entrada
    char jogador = 'A'; // Jogador atual ('A' ou 'B')
    char terminatorChar; // Variável para capturar caracteres extras na entrada
    int jogadas = 0; // Contador de jogadas realizadas
    int extra = 0; // Flag para indicar jogada especial
    int repete = 0; // Flag para evitar alternância desnecessária de jogador

    // Solicitar K ao usuário e verificar se é um número inteiro entre 2 e 100
    printf("Indique K: ");
    if (scanf("%d%c", &K, &terminatorChar) != 2 || (terminatorChar != '\n' && terminatorChar != ' ') || K < 2 || K > 100) {
        printf("K tem de ser entre 2 e 100.\n");
        return 1;
    }

    sequencia[0] = K / 2; // Inicializa o primeiro elemento da sequência
    sequencia[1] = K / 2; // Inicializa o segundo elemento da sequência

    printf("Sequencia: %d %d  [Joga %c]\n", sequencia[0], sequencia[1], jogador); // Exibe a sequência inicial e o jogador que joga

    while (resultado == 1 && jogadas < K) { // Enquanto o jogo não terminar e não exceder K jogadas
        printf("Jogada (indice valor):\n"); // Solicita a jogada do jogador
        scanf("%d %d", &indice, &valor); // Lê o índice e o valor

        if (indice < 0) { // Caso o índice seja inválido (< 0)
            sequencia[0] = valor; // Atualiza o valor na primeira posição
        } else if (indice >= n && valor != 0) { // Caso o índice seja maior ou igual ao tamanho da sequência e valor diferente de 0
            sequencia[n++] = valor; // Adiciona o valor no final da sequência
        } else if (indice >= n && valor == 0) { // Caso o índice seja maior ou igual ao tamanho e o valor seja 0
            extra = 1; // Marca como jogada especial
        } else if (valor == 0) { // Caso o valor seja 0 (remover elemento)
            if (n <= 1) { // Se a sequência tiver apenas um elemento
                printf("Não é possível remover mais elementos.\n"); // Exibe mensagem de erro
                continue; // Volta ao início do loop
            }
            for (int i = indice; i < n - 1; i++) { // Desloca os elementos à esquerda
                sequencia[i] = sequencia[i + 1]; // Atualiza a sequência
            }
            n--; // Reduz o tamanho da sequência
            extra = 1; // Marca como jogada especial
        } else if (valor < 0) { // Caso o valor seja negativo (inserir elemento)
            valor = -valor; // Converte o valor para positivo
            for (int i = n; i > indice; i--) { // Desloca os elementos à direita
                sequencia[i] = sequencia[i - 1]; // Atualiza a sequência
            }
            sequencia[indice] = valor; // Insere o valor na posição indicada
            n++; // Aumenta o tamanho da sequência
            extra = 1; // Marca como jogada especial
        } else { // Caso contrário, substitui o valor na posição indicada
            sequencia[indice] = valor; // Atualiza o valor na posição indicada
        }

        jogadas++; // Incrementa o contador de jogadas

        printf("Sequencia: "); // Exibe a sequência atualizada
        for (int i = 0; i < n; i++) { // Itera sobre a sequência
            printf("%d ", sequencia[i]); // Exibe cada elemento da sequência
        }

        resultado = validar(sequencia, n, K); // Verifica a sequência (validação de vitória ou derrota)

        if (resultado == 0) { // Caso o jogador atual perca
            printf("\nJogador %c perdeu.\n", jogador); // Exibe mensagem de derrota
            return 0; // Encerra o programa
        } else if (resultado == 2) { // Caso o jogador atual ganhe
            printf("\nJogador %c ganhou.\n", jogador); // Exibe mensagem de vitória
            return 0; // Encerra o programa
        } else if (jogadas == K) { // Caso o número de jogadas alcance K
            printf("Empate\n"); // Exibe mensagem de empate
            return 0; // Encerra o programa
        }

        if (extra == 1) {
            if (repete == 0) {
                repete = 1; // Permite repetir a jogada
            } else {
                jogador = (jogador == 'A') ? 'B' : 'A'; // Alterna o jogador
                repete = 0; // Reseta a repetição
            }
        } else {
            jogador = (jogador == 'A') ? 'B' : 'A'; // Alterna o jogador
            repete = 0; // Reseta a repetição
        }
        extra = 0; // Reseta a flag de jogada especial
        printf("[Joga %c]\n", jogador); // Exibe o próximo jogador
    }
}

// Função de validação da sequência
int validar(int sequencia[], int n, int K) {
    int soma = 0, produto = 1, absoluto = 0;

    for (int i = 0; i < n; i++) { // Calcula a soma de todos os elementos
        soma += sequencia[i]; // Soma os elementos
    }
    if (soma > K) return 0; // Jogador perde se a soma for maior que K

    for (int i = 0; i < n; i++) { // Calcula o produto de todos os elementos
        produto *= sequencia[i]; // Multiplica os elementos
    }
    if (produto < K) return 0; // Jogador perde se o produto for menor que K

    for (int i = 0; i < n; i++) { // Calcula a soma das diferenças absolutas
        for (int j = i + 1; j < n; j++) {
            absoluto += abs(sequencia[i] - sequencia[j]); // Soma as diferenças absolutas
        }
    }
    if (absoluto == K) return 2; // Jogador ganha se o absoluto for igual a K

    return 1; // Jogo continua
}