#include <stdio.h>
#include <stdlib.h>

// Protótipo da função de validação
int validar(int sequencia[], int n, int K);
void jogadorArtificial(int sequencia[], int *n, int K, int *indice, int *valor);

int main() {
    int sequencia[100];
    int n = 2, K, indice, valor, resultado = 1;
    char jogador = 'A'; // Jogador atual ('A' ou 'B')
    char terminatorChar; 
    int jogadas = 0;    // Contador de jogadas
    int extra = 0;      // valida jogada extra
    int repete = 0;     // valida repetição extra

    // Solicitar K ao usuário e verificar se é um número inteiro entre 2 e 100
    printf("Indique K: ");
    if (scanf("%d%c", &K, &terminatorChar) != 2 || (terminatorChar != '\n' && terminatorChar != ' ') || K < 2 || K > 100) {
        printf("K tem de ser entre 2 e 100.\n");
        return 1;
    }

    // Inicializa a sequência com dois valores iguais a K/2
    sequencia[0] = K / 2;
    sequencia[1] = K / 2;

    // Mostra a sequência inicial e o jogador que começará jogando
    printf("Sequencia: %d %d  [Joga %c]\n", sequencia[0], sequencia[1], jogador);

    // Enquanto o jogo não terminar (resultado == 1) e o número de jogadas for menor que K
    while (resultado == 1 && jogadas < K) {
        // Solicita ao jogador a jogada (índice e valor)
        printf("Jogada (indice valor):\n");
        scanf("%d %d", &indice, &valor);

        // Verifica se o jogador deseja usar o jogador artificial
        if (indice == -2 && valor == -2) { // Jogador artificial
            jogadorArtificial(sequencia, &n, K, &indice, &valor);
            printf("Jogada artificial: %d %d\n", indice, valor);
        }

        // Processa a jogada
        if (indice < 0) {
            sequencia[0]=valor;
        } else if (valor == 0) {
            // Remover o valor na posição indicada
            if (indice >= n || n <= 1) {
                printf("Nao e possivel remover esse elemento.\n");
                continue;
            }
            for (int i = indice; i < n - 1; i++) {
                sequencia[i] = sequencia[i + 1];
            }
            n--;
            extra = 1;
        } else if (valor < 0) {
            // Inserir o valor na posição indicada
            valor = -valor;
            if (indice > n) {
                printf("Movimento inválido.\n");
                continue;
            }
            for (int i = n; i > indice; i--) {
                sequencia[i] = sequencia[i - 1];
            }
            sequencia[indice] = valor;
            n++;
            extra = 1;
        } else {
            // Substituir ou adicionar o valor na posição indicada
            if (indice >= n) {
                // Adicionar ao final da sequência
                sequencia[n++] = valor;
            } else {
                // Substituir o valor na posição indicada
                sequencia[indice] = valor;
            }
        }

        jogadas++; // Incrementa o contador de jogadas

        // Mostra a sequência atualizada 
        printf("Sequencia: ");
        for (int i = 0; i < n; i++) {
            printf("%d ", sequencia[i]);
        }

        // Verificação da sequência
        resultado = validar(sequencia, n, K);

        // Verifica o resultado da função de validação
        if (resultado == 0) {
            printf("\nJogador %c perdeu.\n", jogador);
            return 0;
        } else if (resultado == 2) {
            printf("\nJogador %c ganhou.\n", jogador);
            return 0;
        } else if (jogadas == K) {
            printf("\nEmpate.\n");
            return 0;
        }

  if (extra == 1) {
            if (repete == 0) {
                repete = 1; // Permite repetir a jogada
            } else {
                jogador = (jogador == 'A') ? 'B' : 'A'; // Alterna o jogador
                repete = 0; // Reseta a repetição
            }
        } else {
            jogador = (jogador == 'A') ? 'B' : 'A'; // Alterna o jogador
            repete = 0; // Reseta a repetição
        }
        extra = 0; // Reseta a flag de jogada especial
        printf("[Joga %c]\n", jogador); // Exibe o próximo jogador
    }
}


// Função Jogador Artificial
void jogadorArtificial(int sequencia[], int *n, int K, int *indice, int *valor) {
    int max_possible_moves = 10000;
    int move_count = 0;
    int found_move = 0;

    // Seleciona o índice I com o maior valor V
    int I = -1;
    int V = -1;
    for (int i = 0; i < *n; i++) {
        if (sequencia[i] > V || (sequencia[i] == V && i < I)) {
            V = sequencia[i];
            I = i;
        }
    }

    int A = 0; // Soma dos números
    for (int i = 0; i < *n; i++) {
        A += sequencia[i];
    }

    // Construir jogadas possíveis com base no índice I
    // Remover (valor = 0) ou reduzir (valor = 1,...,V-1)
    for (int val = 0; val <= V - 1 && move_count < max_possible_moves; val++) {
        int copia[100];
        int copia_n = *n;
        for (int k = 0; k < *n; k++) copia[k] = sequencia[k];
        if (val == 0) {
            // Remover
            for (int k = I; k < copia_n - 1; k++) {
                copia[k] = copia[k + 1];
            }
            copia_n--;
        } else {
            // Reduzir
            copia[I] = val;
        }

        int resultado = validar(copia, copia_n, K);
        move_count++;

        if (resultado == 2) {
            *indice = I;
            *valor = val;
            return;
        } else if (resultado == 1 && !found_move) {
            *indice = I;
            *valor = val;
            found_move = 1;
        }
    }

    // Caso soma dos números A seja menor que K
    if (A < K) {
        // Aumentar (valor = V+1,...,V+(K-A))
        for (int val = V + 1; val <= V + (K - A) && move_count < max_possible_moves; val++) {
            int copia[100];
            int copia_n = *n;
            for (int k = 0; k < *n; k++) copia[k] = sequencia[k];
            copia[I] = val;

            int resultado = validar(copia, copia_n, K);
            move_count++;

            if (resultado == 2) {
                *indice = I;
                *valor = val;
                return;
            } else if (resultado == 1 && !found_move) {
                *indice = I;
                *valor = val;
                found_move = 1;
            }
        }

        // Adicionar um novo número (valor = -1,...,-(K-A))
        for (int val = -1; val >= -(K - A) && move_count < max_possible_moves; val--) {
            int copia[100];
            int copia_n = *n + 1;
            for (int k = 0; k < I; k++) copia[k] = sequencia[k];
            copia[I] = -val; // Inserir o valor
            for (int k = I + 1; k < copia_n; k++) copia[k] = sequencia[k - 1];

            int resultado = validar(copia, copia_n, K);
            move_count++;

            if (resultado == 2) {
                *indice = I;
                *valor = val;
                return;
            } else if (resultado == 1 && !found_move) {
                *indice = I;
                *valor = val;
                found_move = 1;
            }
        }
    }

    // Se nenhuma jogada de vitória foi encontrada, usar a melhor jogada válida
    if (!found_move) {
        // Se nenhuma jogada válida, remover o primeiro elemento
        *indice = 0;
        *valor = 0;
    }
}

// Função de validação da sequência
int validar(int sequencia[], int n, int K) {
    int soma = 0, absoluto = 0;
    long long produto = 1;

    // Calcula a soma de todos os elementos
    for (int i = 0; i < n; i++) {
        soma += sequencia[i];
    }
    if (soma > K) return 0;

    // Calcula o produto de todos os elementos
    for (int i = 0; i < n; i++) {
        produto *= sequencia[i];
        if (produto > K * K) break; // Prevenir overflow
    }
    if (produto < K) return 0;

    // Calcula a soma das diferenças absolutas
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            absoluto += abs(sequencia[i] - sequencia[j]);
        }
    }
    if (absoluto == K) return 2;

    return 1;
}
